## com.fasterxml.jackson.databind.ser.std
Class MapSerializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonSerializer<T>
          com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
              com.fasterxml.jackson.databind.ser.ContainerSerializer<Map<?,?>>
                  com.fasterxml.jackson.databind.ser.std.MapSerializer

All Implemented Interfaces:
  SchemaAware, ContextualSerializer

    public class MapSerializer

extends ContainerSerializer<Map<?,?>>
implements ContextualSerializer

Standard serializer implementation for serializing {link java.util.Map} types.

Note: about the only configurable setting currently is ability to filter out entries with specified names.

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer
`JsonSerializer.None`

Field Summary
`protected PropertySerializerMap` `_dynamicValueSerializers` If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.
`protected HashSet<String>` `_ignoredEntries` Set of entries to omit during serialization, if any
`protected JsonSerializer<Object>` `_keySerializer` Key serializer to use, if it can be statically determined
`protected JavaType` `_keyType` Declared type of keys
`protected BeanProperty` `_property` Map-valued property being serialized with this instance
`protected JsonSerializer<Object>` `_valueSerializer` Value serializer to use, if it can be statically determined
`protected JavaType` `_valueType` Declared type of contained values
`protected boolean` `_valueTypeIsStatic` Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)
`protected TypeSerializer` `_valueTypeSerializer` Type identifier serializer used for values, if any.
`protected static JavaType` `UNSPECIFIED_TYPE`

Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer
`_handledType`

Constructor Summary
`protected` `MapSerializer(HashSet<String> ignoredEntries, JavaType keyType, JavaType valueType, boolean valueTypeIsStatic, TypeSerializer vts, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer)`
`protected` `MapSerializer(MapSerializer src, BeanProperty property, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer)`
`protected` `MapSerializer(MapSerializer src, TypeSerializer vts)`

Method Summary
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)`
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
`MapSerializer` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`static MapSerializer` `construct(String[] ignoredList, JavaType mapType, boolean staticValueType, TypeSerializer vts, JsonSerializer<Object> keySerializer, JsonSerializer<Object> valueSerializer)`
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
`JsonSerializer<?>` `getKeySerializer()` Accessor for currently assigned key serializer.
`JsonNode` `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
`boolean` `isEmpty(Map<?,?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeFields(Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Method called to serialize fields, when the value type is not statically known.
`protected void` `serializeFieldsUsing(Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> ser)` Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.
`protected void` `serializeTypedFields(Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)`
`void` `serializeWithType(Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`MapSerializer` `withResolved(BeanProperty property, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer)`

Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer
`withValueTypeSerializer`

Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer
`createObjectNode, createSchemaNode, createSchemaNode, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer
`isUnwrappingSerializer, unwrappingSerializer, usesObjectId`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### UNSPECIFIED_TYPE

    protected static final JavaType UNSPECIFIED_TYPE

### _property

    protected final BeanProperty _property

  Map-valued property being serialized with this instance

### _ignoredEntries

    protected final HashSet<String> _ignoredEntries

  Set of entries to omit during serialization, if any

### _valueTypeIsStatic

    protected final boolean _valueTypeIsStatic

  Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)

### _keyType

    protected final JavaType _keyType

  Declared type of keys

### _valueType

    protected final JavaType _valueType

  Declared type of contained values

### _keySerializer

    protected JsonSerializer<Object> _keySerializer

  Key serializer to use, if it can be statically determined

### _valueSerializer

    protected JsonSerializer<Object> _valueSerializer

  Value serializer to use, if it can be statically determined

### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

  Type identifier serializer used for values, if any.

### _dynamicValueSerializers

    protected PropertySerializerMap _dynamicValueSerializers

  If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.

Constructor Detail

### MapSerializer

    protected MapSerializer(HashSet<String> ignoredEntries,
                            JavaType keyType,
                            JavaType valueType,
                            boolean valueTypeIsStatic,
                            TypeSerializer vts,
                            JsonSerializer<?> keySerializer,
                            JsonSerializer<?> valueSerializer)

### MapSerializer

    protected MapSerializer(MapSerializer src,
                            BeanProperty property,
                            JsonSerializer<?> keySerializer,
                            JsonSerializer<?> valueSerializer)

### MapSerializer

    protected MapSerializer(MapSerializer src,
                            TypeSerializer vts)

Method Detail

### _withValueTypeSerializer

    public MapSerializer _withValueTypeSerializer(TypeSerializer vts)

  Description copied from class: `ContainerSerializer`
  Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

  Specified by:
    `_withValueTypeSerializer` in class `ContainerSerializer<Map<?,?>>`

### withResolved

    public MapSerializer withResolved(BeanProperty property,
                                      JsonSerializer<?> keySerializer,
                                      JsonSerializer<?> valueSerializer)

### construct

    public static MapSerializer construct(String[] ignoredList,
                                          JavaType mapType,
                                          boolean staticValueType,
                                          TypeSerializer vts,
                                          JsonSerializer<Object> keySerializer,
                                          JsonSerializer<Object> valueSerializer)

### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                              BeanProperty property)
                                       throws JsonMappingException

  Description copied from interface: `ContextualSerializer`
  Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

  Specified by:
    `createContextual` in interface `ContextualSerializer`
  Parameters:
    `provider` - Serializer provider to use for accessing config, other serializers
    `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
  Returns:
    Serializer to use for serializing values of specified property; may be this instance or a new instance.
  Throws:
    `JsonMappingException`

### getContentType

    public JavaType getContentType()

  Description copied from class: `ContainerSerializer`
  Accessor for finding declared (static) element type for type this serializer is used for.

  Specified by:
    `getContentType` in class `ContainerSerializer<Map<?,?>>`

### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

  Description copied from class: `ContainerSerializer`
  Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

  Specified by:
    `getContentSerializer` in class `ContainerSerializer<Map<?,?>>`

### isEmpty

    public boolean isEmpty(Map<?,?> value)

  Description copied from class: `JsonSerializer`
  Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

  Default implementation will consider only null values to be empty.

  Specified by:
    `isEmpty` in class `ContainerSerializer<Map<?,?>>`

### getKeySerializer

    public JsonSerializer<?> getKeySerializer()

  Accessor for currently assigned key serializer. Note that this may return null during construction of `MapSerializer`: depedencies are resolved during `createContextual(com.fasterxml.jackson.databind.SerializerProvider, com.fasterxml.jackson.databind.BeanProperty)` method (which can be overridden by custom implementations), but for some dynamic types, it is possible that serializer is only resolved during actual serialization.

  Since:
    2.0

### serialize

    public void serialize(Map<?,?> value,
                          com.fasterxml.jackson.core.JsonGenerator jgen,
                          SerializerProvider provider)
                   throws IOException,
                          com.fasterxml.jackson.core.JsonGenerationException

  Description copied from class: `JsonSerializer`
  Method that can be called to ask implementation to serialize values of type this serializer handles.

  Specified by:
    `serialize` in class `StdSerializer<Map<?,?>>`
  Parameters:
    `value` - Value to serialize; can not be null.
    `jgen` - Generator used to output resulting Json content
    `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeWithType

    public void serializeWithType(Map<?,?> value,
                                  com.fasterxml.jackson.core.JsonGenerator jgen,
                                  SerializerProvider provider,
                                  TypeSerializer typeSer)
                           throws IOException,
                                  com.fasterxml.jackson.core.JsonGenerationException

  Description copied from class: `JsonSerializer`
  Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

  Default implementation will ignore serialization of type information, and just calls `JsonSerializer.serialize(T, com.fasterxml.jackson.core.JsonGenerator, com.fasterxml.jackson.databind.SerializerProvider)`: serializers that can embed type information should override this to implement actual handling. Most common such handling is done by something like:

        // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
        typeSer.writeTypePrefixForScalar(value, jgen);
        serialize(value, jgen, provider);
        typeSer.writeTypeSuffixForScalar(value, jgen);

  Overrides:
    `serializeWithType` in class `JsonSerializer<Map<?,?>>`
  Parameters:
    `value` - Value to serialize; can not be null.
    `jgen` - Generator used to output resulting Json content
    `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
    `typeSer` - Type serializer to use for including type information
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeFields

    public void serializeFields(Map<?,?> value,
                                com.fasterxml.jackson.core.JsonGenerator jgen,
                                SerializerProvider provider)
                         throws IOException,
                                com.fasterxml.jackson.core.JsonGenerationException

  Method called to serialize fields, when the value type is not statically known.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeFieldsUsing

    protected void serializeFieldsUsing(Map<?,?> value,
                                        com.fasterxml.jackson.core.JsonGenerator jgen,
                                        SerializerProvider provider,
                                        JsonSerializer<Object> ser)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonGenerationException

  Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeTypedFields

    protected void serializeTypedFields(Map<?,?> value,
                                        com.fasterxml.jackson.core.JsonGenerator jgen,
                                        SerializerProvider provider)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonGenerationException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### getSchema

    public JsonNode getSchema(SerializerProvider provider,
                              Type typeHint)

  Description copied from class: `StdSerializer`
  Default implementation simply claims type is "string"; usually overriden by custom serializers.

  Specified by:
    `getSchema` in interface `SchemaAware`
  Overrides:
    `getSchema` in class `StdSerializer<Map<?,?>>`
  Parameters:
    `provider` - The serializer provider.
    `typeHint` - A hint about the type.
  Returns:
    Json-schema for this serializer.

### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              Class<?> type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

  Throws:
    `JsonMappingException`

### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              JavaType type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

  Throws:
    `JsonMappingException`

Copyright © 2012 fasterxml.com. All Rights Reserved.